#!/bin/bash

echo Content-type: text/plain
echo ""

# rsync my R programs into /var/www/Public/RPackageWeb/files/source. Execute with:
# /var/www/Public/CTFSRPackage/collectprograms.bat

UTILpath="/home/condit/programs/R/utilities"
MAPpath="/home/condit/programs/R/map"
GISpath="/home/condit/programs/R/gis"
Rpath="/home/condit/programs/CTFSRpackage"

# Ryan biomass/do_diversity_biomass.r biomass/diversity_biomass.r 

PROGpath="/home/condit/data"
prog=( mortality/mortality.r growth/growth.r growth/growthfit.bin.r growth/growthfit.graph.r 
       biomass/biomass.CTFSdb.r topography/solvetopo.r topography/slope.r topography/imageJ.r 
       abundance/abundance.r demogchange/abund.fit.CTFS.r demogchange/demogChange.r speciesarea/spparea.r 
       spatial/block.analysis.r spatial/NeighborDensityFun.r spatial/RipUvK.r recruitment/recruitment.r )
# Excluded now reproduction/contingency.r 
desc=( mortality/description.txt growth/description.txt biomass/description.txt topography/description.txt spatial/description.txt 
       abundance/description.txt demogchange/description.txt recruitment/description.txt speciesarea/description.txt )
# Excluded now reproduction/description.txt

for program in `ls $UTILpath/*.r $UTILpath/description.txt`
  do
   rsync -av $program /var/www/Public/CTFSRPackage/files/source/utilities --exclude 'utilitiesLatex.r' --exclude 'utilitiesMySQL.r' --exclude 'utilitiesHTML.r' --exclude 'model.error.r'
   # echo $program " to " /var/www/Public/CTFSRPackage/files/source/utilities
  done

# quadfunc.r is in the programs/gis folder but will go in spatial in the R Package; nothing else in gis goes yet
for program in `ls $GISpath/*.r $GISpath/description.txt`
  do
   rsync -av $program /var/www/Public/CTFSRPackage/files/source/spatial \
            --exclude 'quadfuncRC.r' --exclude 'speciesmap.r' --exclude 'Rgis.r' --exclude 'readGPSscript.r' \
            --exclude 'kriging.r' --exclude 'panama.map.r' --exclude 'RSamplesRReeves.r' --exclude 'ExtractWaypoints.r'
   # echo $program " to " /var/www/Public/CTFSRPackage/files/source/utilities
  done

for program in `ls $MAPpath/*.r $MAPpath/description.txt`
  do
   rsync -av $program /var/www/Public/CTFSRPackage/files/source/map
   # echo $program " to " /var/www/Public/CTFSRPackage/files/source/map
  done
  
for program in ${prog[@]}
  do
   rsync -av $PROGpath/$program /var/www/Public/CTFSRPackage/files/source/$program
   # echo $PROGpath/$program " to " /var/www/Public/CTFSRPackage/files/source/$program
  done

for description in ${desc[@]}
  do
   rsync -av $PROGpath/$description /var/www/Public/CTFSRPackage/files/source/$description
   # echo $PROGpath/$description " to " /var/www/Public/CTFSRPackage/files/source/$description
  done

