#!/bin/bash

echo Content-type: text/plain
echo ""

# rsync the CTFS R Package from my laptop to Harvard. This also sources the startCTFS.r to create CTFSRPackage.rdata.
# First collectprograms.bat must be run, then global_table_update locally ;
# /var/www/Public/CTFSRPackage/export.bat Harvard
# /var/www/Public/CTFSRPackage/export.bat Bradley 
# (pass STRI#1)
# then global_table_update at remote server.

## To get the R package over to other server, from condit@euler.arnarb.harvard.edu
# rsync -ave ssh rcondit@ctfs.arnarb.harvard.edu:/var/www/html/Public/CTFSRPackage/CTFSRPackage.rdata /home/CTFS
# chgrp CTFS /home/CTFS/CTFSRPackage.rdata
# chmod 777 /home/CTFS/CTFSRPackage.rdata

# from laptop, but privileges are restricted then
# rsync -ave ssh /var/www/Public/CTFSRPackage/CTFSRPackage.rdata condit@euler.arnarb.harvard.edu:/home/CTFS

if [ -z $1 ]
 then echo Must enter either Harvard or Bradley as the single argument
 exit
fi

Rscript /var/www/Public/CTFSRPackage/saveRpackage.r /var/www/Public/CTFSRPackage/

destination=$1
excludefile="/var/www/Public/CTFSRPackage/excludersync.txt"
sourcefolder="/var/www/Public/CTFSRPackage"
rdatafile="/var/www/Public/CTFSRPackage/CTFSRPackage.rdata"

if [ $destination == "Harvard" ]
 then 
  rsync -ave ssh $sourcefolder rcondit@ctfs.arnarb.harvard.edu:/var/www/html/Public --exclude-from $excludefile
  rsync -ave ssh $rdatafile condit@euler.arnarb.harvard.edu:/home/CTFS
elif [ $destination == "Bradley" ] 
 then rsync -ave ssh $sourcefolder bradleyguest@capstone.bradley.edu:/home/bradleyguest/public_html/Tobias --exclude-from $excludefile
fi
