# An Rscript whose purpose is to source the entire package, using startCTFS, then save to an rdata file directly in the location
# from which it can be downloaded. This can be executed a the Harvard server to create the rdata file there.

# The path where source code is found is passed as an argument

# execute at laptop
# Rscript /var/www/Public/CTFSRPackage/saveRpackage.r /var/www/Public/CTFSRPackage/
# execute at Harvard
# Rscript /var/www/html/Public/CTFSRPackage/saveRpackage.r /var/www/html/Public/CTFSRPackage/
# execute at Bradley
# Rscript /home/bradleyguest/public_html/Tobias/CTFSRPackage/saveRpackage.r ~/public_html/Tobias/CTFSRPackage/

path=commandArgs(trailingOnly=TRUE)[1]
outfile='CTFSRPackage.rdata'

sourcepath=paste(path,'files/source',sep='')
startfile=paste(sourcepath,'/startCTFS/startCTFS.r',sep='')
source(startfile)
startCTFS(folder=sourcepath)

fulloutfile=paste(path,outfile,sep='')
rm(path)
rm(sourcepath)
rm(startfile)

save(list=ls(),file=fulloutfile)

cat('Saved R functions in ', fulloutfile,'\n')

q(save="no")

