<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
|--------------------------------------------------------------------------
| File and Directory Modes
|--------------------------------------------------------------------------
|
| These prefs are used when checking and setting modes when working
| with the file system.  The defaults are fine on servers with proper
| security, but you may wish (or even need) to change the values in
| certain environments (Apache running a separate process for each
| user, PHP under CGI with Apache suEXEC, etc.).  Octal values should
| always be used to set the mode correctly.
|
*/
define('FILE_READ_MODE', 0644);
define('FILE_WRITE_MODE', 0666);
define('DIR_READ_MODE', 0755);
define('DIR_WRITE_MODE', 0777);

/*
|--------------------------------------------------------------------------
| Database Modes
|--------------------------------------------------------------------------
|
| These constants define the username, password, and database that is the default.
| These are used in config/database.php, and are defined here for ease of alteration, and for access
| outside of that script.
*/


define("DB_HOSTNAME", "localhost");
define("DB_USERNAME", "CTFSRPackage");
define("DB_PASSWORD" , "CTFS");
define("DB_DATABASE" , "R_scripts");

/*
|--------------------------------------------------------------------------
| File Stream Modes
|--------------------------------------------------------------------------
|
| These modes are used when working with fopen()/popen()
|
*/

define('FOPEN_READ', 							'rb');
define('FOPEN_READ_WRITE',						'r+b');
define('FOPEN_WRITE_CREATE_DESTRUCTIVE', 		'wb'); // truncates existing file data, use with care
define('FOPEN_READ_WRITE_CREATE_DESTRUCTIVE', 	'w+b'); // truncates existing file data, use with care
define('FOPEN_WRITE_CREATE', 					'ab');
define('FOPEN_READ_WRITE_CREATE', 				'a+b');
define('FOPEN_WRITE_CREATE_STRICT', 			'xb');
define('FOPEN_READ_WRITE_CREATE_STRICT',		'x+b');

/* Tobias's contants for the CTFS server. */

define('BASE_URL',"http://ctfs.arnarb.harvard.edu/Public/CTFSRPackage/");

// echo "Path: "; echo system("pwd"); exit();

define('ABS_HELP_URL',"files/help/");
define('WEB_HELP_URL',"http://ctfs.arnarb.harvard.edu/Public/CTFSRPackage/files/help/");
define('WEB_FILE_URL',"http://ctfs.arnarb.harvard.edu/Public/CTFSRPackage/files/");

//These are the URLs relative to the FILE_URL directory. .
define('SOURCE_URL',"source/");
define('TUTORIAL_URL',"tutorials/");
define('OVERVIEW_URL',"overview/");

//Defines the name of the TXT file which contains topic description.
//Will be found in each topic directory.
define('TOPIC_DESCRIPTION_FILE',"description.txt");

define('ABS_FILE_URL',"files/");

//define('TUTORIAL_ROOT',"http://ctfs.arnarb.harvard.edu/Public/CTFSRPackage/tutorials/");
define('TUTORIAL_ROOT',WEB_FILE_URL.TUTORIAL_URL);


    //Below are the delimiters in the package files.
    //If packages dont' follow this delimiting scheme, they won't be loaded properly into the database.
    define("SUPBEG","# <supplemental>");
     define("SUPEND","# </supplemental>");
    define("NLC","\n# ");
    define("DESCEND", "=function(");
    define("DESCBEG2","<description>");
     define("DESCEND2","</description>");
     define("ARGSBEG","<arguments>");
     define("ARGSEND","</arguments>");
     define("SAMPBEG","<sample>");
     define("SAMPEND","</sample>");
     define("NAMEBEG","<name>");
     define("NAMEEND","</name>");
     define("SOURCEBEG","<source>");
     define("SOURCEEND","</source>");
     define("TITLEBEG","<title>");
     define("TITLEEND","</title>");
     define("SHORTTITLEBEG","SHORT_TITLE:");
     define("SHORTTITLEEND","END_SHORT_TITLE");
     define("HTMLTITLEBEG","TITLE:");
     define("HTMLTITLEEND","END_TITLE");
     define("HTMLDESCBEG","DESCRIPTION:");
     define("HTMLDESCEND","END_DESCRIPTION");
     define("DISPLAYBEG","<display>");
     define("DISPLAYEND","</display>");
     define("UPDATEBEG","<update>");
     define("UPDATEEND","</update>");
     define("FUNCTIONBEG","<function>");
     define("FUNCTIONEND","</function>");

//This value is defined so that files that are too large are blocked. This is in case a virus or some unacceptable file is in the source directory.
define("MAX_FILE_SIZE", 3000000);

//Define the allowed package and tutorial file types here, delimited by commas. MUST BE LOWERCASE.
define("ALLOWED_FILE_EXT","r,html");

//This is the characters to be deleted from strings being input to the MySQL database.
define("DELETECHARS","\n,\r,\r\n,\n\r" );
//This is characters which must have an escape slash inserted before being inserted to the MySQL database.
define("SLASHCHARS","'*\t=><:)({}*");

define("SLASH","~slash~");
//Used as an intermediate character in parsing arguments.
define("SQ","~");

/* End of file constants.php */
/* Location: ./system/application/config/constants.php */
