<?php

class Filesync extends Controller {

      //This controller is the navigation center for the webpage. Each of these independent functions contains the top-level pages:
      //HOME, PERSONNEL, TOPICS
      //and the associated information. It is meant to have minimal information about each webpage; content can be located in the appropriate subdirectory:
      //system/applications/views/content
      //and sidebar content:
      //system/applications/views/leftmenu or /rightmenu
      //note that not all of the top-level pages have sidebars

	function __construct()
	{
		parent::Controller();
                $this->load->helper('url');
                $this->load->helper('file');
                $this->load->helper('tcs_functions');
                $this->load->helper('filesync_tcs');
                $this->load->helper('ftp_functions_tcs');
                $this->load->helper('directory');
                $this->load->helper('download');
                $this->load->database();
                $this->load->model('filesyncmodel');
                $this->load->library('ftp');

	}


//This is the grand master function, which updates the R file and TUTORIAL file databases.
//$display=TRUE means it shows the stats for every function.
function global_table_update($display=FALSE)
{    

     $filetablename = "file";
     $tablename="function";
     $topics_table="topics";
     $filelist = $this->db->query("SELECT fullpath FROM file WHERE type = 'package'")->result() ;

     $ar = array('global' => array('pagename' => "Global Database Update Script")) ;
     $this->load->view('template/head',$ar);
 
     echo '<div id="content"><div class="flower"></div><div class="post"><h1 style= "margin-top: 150px";>Welcome to CTFS Website File Upload Page</h1><div class="entry"><p >';

    $this->source_output(TRUE);
     
    $num = $this->file_table_update($display,$filetablename);

    $this->topic_table_update( $display,$topics_table);

    $this->function_table_update($display,$tablename);
     sleep(5);
    $this->argument_table_update($display,"argument");


    $counter2 = $this->tutorial_table_update($display);
    //    echo "I am a mental case for programming in php<br>"; exit();

    echo "</p></div></div></div>";
}


// This reads all files in the SOURCE directory and extracts those named .r or .R. Results match those of 
// $filelist = $this->db->query("SELECT file FROM file WHERE type = 'package'")->result() ;
// Output is written to a text file called sourceCTFS.r, with R source command included, to be included in CTFS R package. 
function source_output($display=FALSE)
{    
     //include('../../../conn/GeneralPHPUtilities.php');
     //echo ABS_FILE_URL.SOURCE_URL; exit();
     $program=rc_search_Rfunction(tcs_directory_scan(ABS_FILE_URL.SOURCE_URL,$remove=2));
     
     $outfile=ABS_FILE_URL.SOURCE_URL.'startCTFS/startCTFS.r';
     $fp = fopen($outfile, 'w');
     if(!$fp) { echo 'could not open for writing to ' . $outfile; exit(); }
     
     fprintf($fp, "# <function>\n");
     fprintf($fp, "# <name>\n# startCTFS\n# </name>\n");
     fprintf($fp, "# <description>\n");
     fprintf($fp, "# Function to source all components of CTFS R package. Load all CTFS packages into a folder,\n");
     fprintf($fp, "# then when opening R, execute this function, passing the folder name.\n");
     fprintf($fp, "# </description>\n");    
     fprintf($fp, "# <arguments>\n# \n# </arguments>\n");
     fprintf($fp, "# <sample>\n# \n# </sample>\n");
     fprintf($fp, "# <source>\n");
     fprintf($fp, "startCTFS=function(folder)\n");
     fprintf($fp, "{\n");
     foreach($program as $p) fprintf($fp,"\tsource(paste(folder,'/%s',sep=''))\n",$p);
     fprintf($fp, "}\n");
     fprintf($fp, "# </source>\n");
     fprintf($fp, "# </function>\n");
     
     exec("chown condit $outfile");
     exec("chmod 777 $outfile");
}


//This function reads the directories and updates the files in them.
function file_table_update($display=FALSE,$tablename="file")
{
  return $this->filesyncmodel->file_table_update($tablename,$display);
}

function function_table_update($display=FALSE,$tablename="function")
{
  //This accesses the list of packages.
  $packagelist = $this->db->query("SELECT fullpath FROM file WHERE type = 'package'")->result() ;
   return $this->filesyncmodel->function_table_update($packagelist,$tablename,$display);
}

//Automatically updates the tutorial table, based on $tutlist.
function tutorial_table_update($display=FALSE,$tablename="tutorials")
{ 
   //This accesses the list of tutorials.
  $tutlist = $this->db->query("SELECT fullpath FROM file WHERE type = 'tutorial'")->result() ;

  return $this->filesyncmodel->tutorial_table_update($tutlist,$tablename,$display) ;

}

//Loads description.txt from a topic directory and loads its contents into database.
function topic_table_update($display=FALSE)
{          $tablename = "topics";
          //This defines the list of description.txt files which contain topic descriptions.
          $topic_list = tcs_find_directories(ABS_FILE_URL.SOURCE_URL);


  return $this->filesyncmodel->topic_table_update($tablename,$topic_list,$display);
}

function argument_table_update($display=FALSE)
{    $packagelist = $this->db->query("SELECT * FROM file WHERE type = 'package'")->result() ;
  return $this->filesyncmodel->argument_table_update("argument" ,$packagelist,$display);
}


}
/* End of file filesync.php */
/* Location: ./system/application/controllers/filesync.php */
