<?php

class Web extends Controller {

      //This controller is the navigation center for the webpage. Each of these independent functions contains the top-level pages:
      //HOME, PERSONNEL, TOPICS
      //and the associated information. It is meant to have minimal information about each webpage; content can be located in the appropriate subdirectory:
      //system/applications/views/content
      //and sidebar content:
      //system/applications/views/leftmenu or /rightmenu
      //note that not all of the top-level pages have sidebars

	function __construct()
	{
		parent::Controller();
                $this->load->helper('url');
                $this->load->helper('file');
               $this->load->helper('tcs_functions');
               $this->load->helper('directory');
                $this->load->helper('download');
                //This initializes the list of R packages, which is the true totally global datapoint.
                $this->data['Rf'] =  $this->db->query("SELECT * FROM file WHERE display = true and type='package'")->result() ;
                //$this->data['tut'] =  array("imageJTutorial","growthfitAnalysis");
                $this->data['tut'] = $this->db->query("SELECT * FROM tutorials WHERE display = true")->result() ;

        }

	function index()
	{

                $global_info = array(
                   "content" => 'content',  //This is the name of the content file which contains this webpage.
                   "pagename" => 'CTFS R Package', //This is the name of the webpage, as displayed on the title bar and in the header.
                   "Rfiles" => $this->data['Rf']
                 );

                 $this->load->view('navigator', array("global"=>$global_info));
                //echo 'Your are working! index function loaded, view set as '.$data;
	}
	
	function data_format($subpage=NULL)
	{       $format_list = array("tree"=>"Tree Tables","stem"=>"Stem Tables","species"=>"Species Data",
	                             "wooddensity"=>"Wood Density","elevation"=>"Elevation");

            $extrac = "/";
            switch($subpage)
                 {
                   default:
                         $extrac=NULL;
                         $subpagename="Top Level";
                         break;
                   case "tree_data":
                        $subpagename = "Tree Table";
                         break;
                   case "stem_data":
                        $subpagename = "Stem Table";
                         break;
                   case "species_data":
                        $subpagename = "Species Table";
                         break;
                   case "wooddensity_data":
                        $subpagename = "Wood Density";
                         break;
                   case "elevation_data":
                        $subpagename = "Elevation";
                         break;
                 }


                 $global_info = array(
                   "content" => 'data_format'.$extrac.$subpage,  //This is the name of the content file which contains this webpage.
                   //"sidebar" => 'personnel',  //This is the name of the menu files which contains this webpage.
                   "pagename" => 'CTFS R-Format Tables', //This is the name of the webpage, as displayed on the title bar and in the header.
                   "subpage" => $subpage,
                   "subpagename" => $subpagename,
                   "Rfiles"=> $this->data['Rf'],
                   "tree_columns"=> $this->db->query("SELECT * FROM data_format WHERE is_tree_data = true")->result(),
                   "stem_columns"=> $this->db->query("SELECT * FROM data_format WHERE is_stem_data = true")->result(),
                   "spp_columns"=> $this->db->query("SELECT * FROM data_format WHERE is_spp_data = true")->result(),
                   "wsg_columns"=> $this->db->query("SELECT * FROM data_format WHERE is_wsg_data = true")->result(),
                   "elev_columns"=> $this->db->query("SELECT * FROM data_format WHERE is_elev_data = true")->result(),
                   "format_list" => $format_list
                 );
                 
                   # echo var_dump(($this->load)); exit();
                 $this->load->view('navigator', array("global"=>$global_info));

        }

        function tutorials($subpage=NULL)
        { //Specify the tutorial root and list of tutorials, by directory name.
          $tutorial_root =  TUTORIAL_ROOT;
          //$tutorial_list = array("imageJTutorial","growthfitAnalysis");
          $tutorial_list = $this->data['tut'];
           //These initializes variabels which may or may not be needed.
               $global_info = NULL;               //Contains all info that is global to Topics page.
               $tutorial_info = NULL;              //Contains info for selected package.
              $file_contents= NULL;
              $title = NULL;
              $allsubpages = NULL;

          $getter = NULL;
          if($subpage==NULL)
          {
           $getter = tcs_list_tutorials($tutorial_list,TRUE);
          }


          //For this function, $subpage is the directory where the tutorial is to be found.

           if($subpage != NULL){
             //This reads the file.
              $file_contents = file_get_contents(TUTORIAL_ROOT.$subpage);
			  $file_contents = str_replace(HTMLDESCBEG,"",$file_contents);
			  $file_contents = str_replace(HTMLDESCEND,"",$file_contents);
			  $file_contents = str_replace(SHORTTITLEBEG,"",$file_contents);
			  $file_contents = str_replace(SHORTTITLEEND,"",$file_contents);
              //echo 'link rel="stylesheet" type="text/css" href="'.$tutorial_root.$subpage.'/'; echo "<br>";
              //echo 'link rel="stylesheet" type="text/css" href="'; 
              //exit();
              
              //This replaces all relative instances of the image with global ones, so they show up.
               $file_contents = str_replace('src="','src="'.$tutorial_root.$subpage.'/',$file_contents);

              //This replaces the relative stylesheet reference with a global one.
              $file_contents = str_replace('link rel="stylesheet" type="text/css" href="',
                                           'link rel="stylesheet" type="text/css" href="'.$tutorial_root.$subpage.'/',
                                            $file_contents);
              $title =  tcs_string_find( $file_contents,'<h2 class="titleHead">','</h2><div class="authors"><span class="author" >');
              // echo "XXXXX" . $title . "<br>"; exit();
              
              $tutorial_info = array(
                   "subpage" => $subpage,
                   "file_contents" => $file_contents,
                   "subpageurl" => $tutorial_root.$subpage ,
                   "subpagetitle" => $title
              );
           }

              $global_info = array(
                     "content" => 'tutorials',       //This is the name of the content file which contains this webpage.
                     "pagename" => 'CTFS Tutorials', //This is the name of the webpage, as displayed on the title bar and in the header.
                     //"subpage" => $subpage,
                     //"file_contents" => $file_contents,
                    // "subpageurl" => $tutorial_root.$subpage ,
                     //"subpagetitle" => $title ,
                     "all_tutorials" => $this->data['tut'],
                     "Rfiles"=> $this->data['Rf'],
                 );

                 $data1 = array("global"=>$global_info,"tutorial_info"=>$this->data['tut'],"tutorial"=>$tutorial_info);

        $this->load->view('navigator', $data1);

        }

        function topics($subpage=NULL,$function1=NULL)
	{        $this->load->library('Rscriptdb');

               //These initialize the data arrays.
               $global_info = NULL;               //Contains all info that is global to Topics page.
               $package_info = NULL;              //Contains info for selected package.
               $function_info = NULL;             //Contains info for selected function.
               $subpage = str_replace(SLASH,"/",$subpage);


                 if($subpage!=NULL)
                 { $topic1 = $this->db->query("SELECT * FROM file WHERE fullpath='".SOURCE_URL.$subpage."'")->result();
                   $topic = $topic1[0]->topic;

                          $package_info = array(
                            "functionlist" => $this->db->query("SELECT function FROM function WHERE display = true AND file='".$subpage."'")->result(),
                            "packagename" => tcs_slash($subpage) ,
                            "topic_info" => $this->db->query("SELECT * FROM topics WHERE  pathmatch='".$topic."'")->result(),
                            "packagesource" => ABS_FILE_URL.SOURCE_URL.$subpage, //."/index.html",
                            "packagehelpname" => basename($subpage,".r").".pdf"
                          );

                          if($function1!=NULL){
                            
                            //The following lines access the databases.

                            //Accesses function entries in argument database, creating an array containing all of the arguments and default values.
                            $transit = $this->db->query("SELECT * FROM argument WHERE function = '".$function1."'")->result();

                             //Accesses function description.
                            $transit1 =  $this->db->query("SELECT * FROM function WHERE file = '".$subpage."' AND function = '".$function1."'")->result();

                            //This pulls data class data from data_format table, to match any arguments with their functino description.
                            $transit2 = $this->db->query("SELECT * FROM data_format")->result();

                            $function_info = array(

                              "function_argument" => $this->db->query("SELECT argument FROM argument WHERE function = '".$function1."'")->result(),
                              "function_argument1" => $transit,
                              //Below all the text info is pulled from the database, which is stored in $transit1.
                              //It pulls [0] since there should only be one element in the table which matches the query in $transit1.
                              "function_description" => $transit1[0]->description, //This passes a block of text which si the function description.
                              "function_argument_text" => $transit1[0]->arguments,
                              "function_sample_text" => $transit1[0]->sample,
                              "function_name" => $function1 ,
                              "function_source" =>  $this->rscriptdb->find_function_source($function1),
                              "data_variables"=> $transit2
                              //This creates a single array from this database access. This allows use of array_search and other functions.
                              //"data_variables_names"=> tcs_array_db_column($transit2, "column_name")
                            );

                           }

                 }

                 $global_info = array(
                   "content" => 'topics',  //This is the name of the content file which contains this webpage.
                   "sidebar" => 'topics',  //This is the name of the menu files which contains this webpage.
                   "pagename" => 'Topics' ,//This is the name of the webpage, as displayed on the title bar and in the header.

                   "Rfiles" => $this->data['Rf']
                 );


                 $data1 = array("global"=>$global_info,"package"=>$package_info,"function"=>$function_info);

                 $this->load->view('navigator', $data1);

        }



}

/* End of file welcome.php */
/* Location: ./system/application/controllers/welcome.php */
