<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');


//This reads an entire file, and returns and array containing all the functions within it.
//The file path must incldue source, i.e. $file must be like SOURCE_URL."utilities.r"
function file_package_read($file="utilities.r",$display=FALSE)
{

    $the_string = file_get_contents(ABS_FILE_URL.$file);
    # if(strstr($the_string,'imageJ')) { echo "HERE IS STRING: <br>".$the_string; exit(); }

    $b = 1;
    while($the_string != FALSE){

        $the_array[] = get_next_function($the_string,$b);
        $the_string = chop_one_function($the_string);
        $b = $b + 1;

    }

    for($count = 0; $count < count($the_array)- 1;$count+=1) {
       $returner[] = $the_array[$count];


    }
    //If dispaly is set, the results are outputted.
    if($display)
    {   echo "<h3>The following ".(count($returner) - 1)." functions have been read:</h3>";
        foreach($returner as $k){
        echo "Function: ".$k['function'].", fileorder: ".$k['fileorder'];
        echo "<br> Description: ".$k['description'];
        if(isset($k['arguments'])) echo "<br> Arguments: ".$k['arguments'];
        if(isset($k['sample'])) echo "<br> Sample: ".$k['sample'];
        echo "<br><hr>";
    }
    }

    return $returner;

}


//This function goes through a file and parses for the next function Description, Sample, Arguments, and Name.
//It has to be used slightly differently for HTML tutorials, source code, and the description.txt file. The last
//two arguments indicated which is needed.
function get_next_function($string,$index,$istutorial=FALSE,$isdescription=FALSE)
{   
     //These control whether the tutoiral or package is displayed and updated.
     //Uses strcasecmp since tcs_string_find returns a STRING, NOT A BOOLEAN. 
     //This functino returns "0" if the strings match.
     //Display is stored in the database. It must be a '0' or '1', numeric, since that is the syntax MySQL requires.
     
     //Update does not go to the database, but blocks the function from being updated during file synchronization.
     //If this happens, text is displayed showing it.

	#if(!$istutorial) { echo "istutorial is FALSE"; exit(); }
	
	if( chop_one_function($string) == FALSE && !$istutorial && !$isdescription )
	{
	}
    else
	{
     if(!$istutorial && !$isdescription) $string = tcs_string_find($string,FUNCTIONBEG,FUNCTIONEND);

	# Following needed because string markers must be different in HTML files, due to Latex->HTML conversion
     if($istutorial) 
		{
			$returner['title'] = tcs_string_find($string,SHORTTITLEBEG,SHORTTITLEEND);			
			$returner['description'] = tcs_string_find($string,HTMLDESCBEG,HTMLDESCEND);
	        # echo "HERE IS returner: <br>".var_dump($returner); exit(); 
		}
     else 
		{
			# echo "Not a tutorial"; exit();
			$returner['title'] = tcs_string_find($string,TITLEBEG,TITLEEND);
			$returner['description'] = tcs_string_find($string,DESCBEG2,DESCEND2);
	        # if(strstr($string,'analyzing tree growth')) { echo "HERE IS returner: <br>".var_dump($returner); exit(); }
		}

     //This returns the function name. Will be blank for tutorial or description
     # if(strstr($string,'analyzing tree growth')) { echo "HERE IS FUNCTION NAME: <br>".tcs_string_find($string,NAMEBEG,NAMEEND); exit(); }
     # if(strstr($string,'analyzing tree growth')) { echo "HERE IS FUNCTION TAG: <br>".htmlspecialchars(NAMEBEG); exit(); }
	  $returner['function'] = tcs_string_find($string,NAMEBEG,NAMEEND);
	  $returner['function'] = trim(str_replace("#","",$returner['function']));
       
      $returner['update'] = tcs_string_find($string,UPDATEBEG,UPDATEEND);
      $returner['sample'] = tcs_string_find($string,SAMPBEG,SAMPEND);
      $returner['arguments'] = tcs_string_find($string,ARGSBEG,ARGSEND);
      $returner['source'] = tcs_string_find($string,SOURCEBEG,SOURCEEND);

     // echo var_dump($returner); exit();
     //$index is an argument, and defines the fileorder.
      $returner['fileorder'] = $index;


     if(strcasecmp( tcs_string_find($string,DISPLAYBEG,DISPLAYEND) , "FALSE" )==0)
		$returner['display'] = 0;
     else $returner['display'] = 1;
     
     $returner['description'] = trim(str_replace("#","",$returner['description']));
     $returner['arguments'] = trim(str_replace("#","",$returner['arguments']));
     $returner['sample'] = trim(str_replace("#","",$returner['sample']));

     # if(strstr($string,'analyzing tree growth')) { echo "HERE IS returner: <br>".var_dump($returner); exit(); }

     return $returner;  
    }
}

//This function chops the first function description from the given file.
function chop_one_function($string) {

     $length =    strpos($string,FUNCTIONEND );
     //If DESCEND can't be found, the entire file has been parsed, and FALSE is returned.
     if($length == FALSE) {
               return FALSE ;
     }  else { 

       return substr($string,$length+ strlen(FUNCTIONEND)); }
}

//This takes in a all arguments from inside function definition brackets.
//And returns an array list of all arguments, with default values.
function process_function_arguments($string,$function,$package_path,$display=FALSE)
{    //Removes any instances of SQ, which would screw up delimiting search.
     $string = str_replace(SQ,SLASH,$string);
     //Defines brackets.
     //Techncially, these should be any characters in an argument definition, inside of which commas can be found.
    $complex = "(),[],{}";

    //Initializing several intermediate variables.
    $stringer = $string;
    $brackets_list = array();
    $max = 30; //Max number of possible parenthsis of each type in an argument field.

    //This goes through each item of complex and sees if its exists in the string.

    //brackets_list contains the locations of all the problems brackets.
    //All commas inside these brackets must be eliminated.
    foreach(explode(",",$complex) as $k)
    {
      //Defines the beginning and end of teh delimiteres, e.g. "(" and ")".
      $first = mb_substr($k,0,1);
      $last = mb_substr($k,1,1);

      $stringer = $string;
      $adj = 0;
      $b = 0;

      while($b < $max)
      {
        //Checks if disallowed bracket is found in $stringer at all.
        if(strpos($stringer,$first) > -1)
        { //If so, then type and location is added to the brackets_list array.

          $brackets_list[] = array (
                              'type'  => $k,
                              'begin' => (strpos($stringer,$first) + $adj),
                              'end'   => (strpos($stringer,$last) + $adj )
           );
           //stringer is shortened, and length added.
           $adj = strpos($stringer,$last) + $adj;
           $stringer = substr($stringer,strpos($stringer,$last) + 1);

        }
      $b += 1;
      }

      

    }
   // $ex = " ~ HERE ~ " ;

    if(count($brackets_list) == 0)
    {

    } else
    {

    $i = $brackets_list[0]['begin'];
    $p  = 0;
   // $replace = array();
    //SQ is the intermediate character takes the place of commas. Make sure it is only one character long.

    $string1 = $string;
    foreach($brackets_list as $n)
      { $start = $n['begin'];
        $end =   $n['end'] ;
        //before_string is the part of string located BEFORE the current element of brackets_list
        $before_string = substr($string,0,$start);
        //after_string is the string located AFTER the current element of brackets_list
        $after_string = substr($string,$end);
        //this redefines string, replacing "," with "SQ" in-between the locations denoted by brackets_list
        $string = $before_string.str_replace(",",SQ,substr($string,$start,($end - $start))).$after_string;
      }

    }
    
    $returner = clean_argument_process($string,$function,$package_path);
    
    return $returner;
}

//Once commas have been removed from inside brackets, this function explodes anda ssigns defautl values of the resulting string.
//Returns an array which is a list of all values needed.
function clean_argument_process($string,$function,$package_path)
{ $p = 1;
  $string = tcs_unslash($string,SQ);
  $array = explode(",",$string);

  foreach($array as $n)
  {
    $inter = explode("=",$n);
    if(count($inter)<2) { $default = ""; }
    else { $default = end($inter) ; }

    $returner[] = array(
      'file' => $package_path,
      'function' => $function,
      'funcorder' => $p ,
      'argument' => reset($inter),
      'defaultvalue' => str_replace(SQ,",",$default),
      'description' => ""

    );
   $p += 1;
  }
  return $returner;

}

/**
 * Octal Permissions
 *
 * Takes a numeric value representing a file's permissions and returns
 * a three character string representing the file's octal permissions
 *
 * @access	public
 * @param	int
 * @return	string
 */	
if ( ! function_exists('octal_permissions'))
{
	function octal_permissions($perms)
	{
		return substr(sprintf('%o', $perms), -3);
	}
}

function table_clear($tablename="function1")
{
  $this->filesyncmodel->function_table_clear($tablename);
}

function drop_surplus_table($tables="test1")
{
    $this->filesyncmodel->drop_table($tables);
}



    //Drops a table from the active database.   returns TRUE if success, FALSE if failure.
function drop_table($name)
{  

         if(table_exists($name)){
          $this->db->query("DROP TABLE IF EXISTS ".$name);
           echo $name." has been dropped from the database.";
           RETURN TRUE;
         } else {
          echo "Table doesn't exist, and can not be dropped.";
          return FALSE;
         }


}

//This functions prepares a string for a query in MySQL.
function tcs_string_cleanup($string)
{
   $badchars1 = "'*\t=><:)({}*";
   $deletechars = array("\n","\r","\r\n","\n\r");

   $string = addcslashes(stripslashes($string),$badchars1);

    return str_replace($deletechars,"",$string);


}

//Scans a directory recursively, and returns an array.
//Tge second argument is the number of elements dropped from the beginning. Necessary since servers typically list an "upper level" directroy at the beginning.
//Each element of the array corresponds to one path and file. Like:
//utilitiesLatex.r
//growth/growth1.r
//growth/growthfit.bin1.r
function tcs_directory_scan($path,$remove=2)
{
   //Scans the directory where soruces are stored. The frist 2 elements are dropped, since they are references to upper level directories.
 $package_list1 = array_slice(scandir($path),$remove);
 foreach( $package_list1 as $subdir)
  { //If the array element is a directory, perform a nested operation.
    if(is_dir($path.$subdir))
    {
     $dir = array_slice(scandir($path.$subdir),$remove);
     foreach($dir as $n)
     {
      if(is_dir($path.$subdir."/".$n))
      {
       $superdir = array_slice(scandir($path.$subdir."/".$n),$remove);
       foreach($superdir as $b)
       {
          if(is_dir($path.$subdir."/".$n."/".$b))
          {
           $megadir = array_slice(scandir($path.$subdir."/".$n."/".$b),$remove);
           foreach($megadir as $p)
           {
           $package_list[] = $subdir."/".$n."/".$b."/".$p;
           }
          } else { $package_list[] = $subdir."/".$n."/".$b; }

       }
      } else{ $package_list[] = $subdir."/". $n; }
     }
    } else{ $package_list[] = $subdir; }
  }
 # echo var_dump($package_list);
 return $package_list;
}

//Finds all directories within a directory. Does not perform a nested operation.   
//Returns all the directories in given path.
function tcs_find_directories($path,$remove=2)
{
    $returner = array_slice(scandir($path),$remove);
    foreach($returner as $k) $list[] = $path.$k;
    $returner = array_filter($list,'is_dir');

    return $returner;
}

/* End of file file_helper.php */
/* Location: ./system/helpers/file_helper.php */
